const BaseOpenApiClient = require('./base-open-api-client')

module.exports = class GroupSyncIterator extends BaseOpenApiClient {
  async getAllItems (params) {
    const { body: { lKeyCount, wstrIterator } } = await this.baseRequest(params)
    const items = await this.baseRequest({
      command: 'GroupSyncIterator.GetNextItems',
      data: { nCount: lKeyCount, szwIterator: wstrIterator },
      connection: params.connection
    })
    await this.baseRequest({
      command: 'GroupSyncIterator.ReleaseIterator',
      data: { szwIterator: wstrIterator },
      connection: params.connection
    })
    items.body.PxgRetVal = items.body.pData.KLCSP_ITERATOR_ARRAY
    return items
  }
}
