const BaseOpenApiClient = require('../base-open-api-client')
const className = 'AdmServerSettings'

module.exports = class AdmServerSettings extends BaseOpenApiClient {
  /**
   * Change shared folder
   * @param {wstrNetworkPath} wstrNetworkPath network path to shared folder
   * @param {Connection} connection
   * @return {Promise.<String>} id of asynchronous operation
   */
  ChangeSharedFolder ({ wstrNetworkPath } = {}, connection) {
    return this.baseRequest({
      command: `${className}.ChangeSharedFolder`,
      data: {
        wstrNetworkPath
      },
      connection
    })
      .then(this.getResult)
  }
}
