const BaseOpenAPIClient = require('../base-open-api-client')
const className = 'ChunkAccessor'

module.exports = class ChunkAccessor extends BaseOpenAPIClient {
  GetItemsChunk ({ strAccessor, nStart = 0, nCount }, connection) {
    return this.baseRequest({
      command: `${className}.GetItemsChunk`,
      data: {
        strAccessor, nStart, nCount
      },
      connection
    }).then(({ body }) => {
      return { result: body.pChunk.KLCSP_ITERATOR_ARRAY }
    }).then((res) => this.deserialize({ body: { PxgRetVal: res.result } }))
  }
  GetItemsCount ({ strAccessor }, connection) {
    return this.baseRequest({
      command: `${className}.GetItemsCount`,
      data: { strAccessor },
      connection
    }).then(this.getResult)
  }
  Release ({ strAccessor }, connection) {
    return this.baseRequest({
      command: `${className}.Release`,
      data: { strAccessor },
      connection
    }).then(this.getBody)
  }
}
