const BaseOpenAPIClient = require('../base-open-api-client')
const className = 'DataProtectionApi'

module.exports = class DataProtectionApi extends BaseOpenAPIClient {
  CheckPasswordSplPpc ({szwPassword}, connection) {
    return this.baseRequest({
      command: `${className}.CheckPasswordSplPpc`,
      data: {
        szwPassword
      },
      connection,
      tranformRequestBodyLogs: body => {
        body.szwPassword = '🙈🙉🙊'
        return body
      }
    })
      .then(this.getResult)
  }

  ProtectDataForHost ({szwHostId, pData}, connection) {
    return this.baseRequest({
      command: `${className}.ProtectDataForHost`,
      data: {szwHostId, pData},
      connection,
      tranformRequestBodyLogs: body => {
        body.pData = '🙈🙉🙊'
        return body
      }
    })
      .then(body => this.getResult(body, 'pDataProtected'))
  }

  ProtectDataGlobally ({pData}, connection) {
    return this.baseRequest({
      command: `${className}.ProtectDataGlobally`,
      data: {pData},
      connection,
      tranformRequestBodyLogs: body => {
        body.pData = '🙈🙉🙊'
        return body
      }
    })
      .then(body => this.getResult(body, 'pDataProtected'))
  }

  ProtectUtf8StringForHost ({szwHostId, szwPlainText}, connection) {
    return this.baseRequest({
      command: `${className}.ProtectUtf8StringGlobally`,
      data: {
        szwHostId,
        szwPlainText
      },
      connection,
      tranformRequestBodyLogs: body => {
        body.szwPlainText = '🙈🙉🙊'
        return body
      }
    })
      .then(this.getResult)
  }

  ProtectUtf8StringGlobally ({szwPlainText}, connection) {
    return this.baseRequest({
      command: `${className}.ProtectUtf8StringGlobally`,
      data: {
        szwPlainText
      },
      connection,
      tranformRequestBodyLogs: body => {
        body.szwPlainText = '🙈🙉🙊'
        return body
      }
    })
      .then(this.getResult)
  }
}
