const BaseOpenAPIClient = require('../base-open-api-client')
const className = 'DatabaseInfo'

module.exports = class DatabaseInfo extends BaseOpenAPIClient {
  /**
   * Get database's files size.
   *
   * @param {*} { args } empty
   * @param {*} connection
   * @returns {int} size of files of database.
   */
  async GetDBSize ({ args }, connection) {
    const body = await this.baseRequest({
      command: `${className}.GetDBSize`,
      connection
    })
    return this.deserialize(body)
  }

  /**
   * Get database's data size.
   *
   * @param {*} { args } empty
   * @param {*} connection
   * @returns {int} size of data of database.
   */
  async GetDBDataSize ({ args }, connection) {
    const body = await this.baseRequest({
      command: `${className}.GetDBDataSize`,
      connection
    })
    return this.deserialize(body)
  }

  /**
   * Get database's events count.
   *
   * @param {*} { args } empty
   * @param {*} connection
   * @returns {int} count of events of database.
   */
  async GetDBEventsCount ({ args }, connection) {
    const body = await this.baseRequest({
      command: `${className}.GetDBEventsCount`,
      connection
    })
    return this.deserialize(body)
  }
}
