const BaseOpenAPIClient = require('../base-open-api-client')
const className = 'HostTagsRulesApi'

module.exports = class HostTagsRulesApi extends BaseOpenAPIClient {
  
  GetRules ({pFields2ReturnArray}, connection) {
    return this.baseRequest({
                              command: `${className}.GetRules`,
                              data:    {pFields2ReturnArray},
                              connection
                            })
               .then(this.deserialize)
  }
  
  UpdateRule ({szwTagValue, pRuleInfo}, connection) {
    let rulesInfo = this.serialize(pRuleInfo)
    return this.baseRequest({
                              command: `${className}.UpdateRule`,
                              data:    {szwTagValue, pRuleInfo: rulesInfo},
                              connection
                            })
               .then(this.deserialize)
  }
  
  DeleteRule ({szwTagValue}, connection) {
    return this.baseRequest({
                              command: `${className}.DeleteRule`,
                              data:    {szwTagValue},
                              connection
                            })
               .then(this.deserialize)
  }
  
  ExecuteRule ({szwTagValue}, connection) {
    return this.baseRequest({
                              command: `${className}.ExecuteRule`,
                              data:    {szwTagValue},
                              connection
                            })
               .then(this.getBody)
  }
  
}