const BaseOpenAPIClient = require('../base-open-api-client')
const className = 'HWInvStorage'

module.exports = class HWInvStorage extends BaseOpenAPIClient {

  GetHWInvObject ({ nObjId }, connection) {
    return this.baseRequest({
      command: `${className}.GetHWInvObject`,
      data: { nObjId },
      connection
    })
    .then(body => this.getResult(body, 'pObj'))
  }

  SetHWInvObject ({ nObjId, pObj }, connection) {
    return this.baseRequest({
      command: `${className}.SetHWInvObject`,
      data: { nObjId, pObj },
      connection
    })
      .then(this.getBody)
  }

  EnumDynColumns ( noParam , connection) {
    return this.baseRequest({
      command: `${className}.EnumDynColumns`,
      data: { },
      connection
    })
    .then(this.getBody)
  }

  AddHWInvObject ( { pObj } , connection) {
    return this.baseRequest({
      command: `${className}.AddHWInvObject`,
      data: { pObj },
      connection
    })
      .then(this.getBody)
  }

  DelHWInvObject2 ( { arrObjId } , connection) {
    return this.baseRequest({
      command: `${className}.DelHWInvObject2`,
      data: { arrObjId },
      connection
    })
      .then(this.getBody)
  }

  AddDynColumn ( { wstrColName } , connection) {
    return this.baseRequest({
      command: `${className}.AddDynColumn`,
      data: { wstrColName },
      connection
    })
    .then(this.getBody)
  }

  DelDynColumn ( { wstrColId } , connection) {
    return this.baseRequest({
      command: `${className}.DelDynColumn`,
      data: { wstrColId },
      connection
    })
    .then(body => this.getResult(body, 'arrDynColumnInfo'))
  }

  GetProcessingRules ( noParam , connection) {
    return this.baseRequest({
      command: `${className}.GetProcessingRules`,
      data: {  },
      connection
    })
      .then(body => this.getResult(body, 'pRules'))
  }

  SetProcessingRules ( { pRules } , connection) {
    return this.baseRequest({
      command: `${className}.SetProcessingRules`,
      data: { pRules },
      connection
    })
      .then(body => this.getResult(body, 'pRules'))
  }

}
