const BaseOpenAPIClient = require('../base-open-api-client')
const className = 'KeyService'

module.exports = class KeyService extends BaseOpenAPIClient {
  /**
   * Method creates a crypto container for chosen host. Data may be decrypted only locally on host
   */
  EncryptDataForHost ({wstrHostId, pData}, connection) {
    return this.baseRequest({
      command: `${className}.EncryptDataForHost`,
      data: {wstrHostId, pData},
      connection,
      tranformRequestBodyLogs: body => {
        body.pData = '🙈🙉🙊'
        return body
      }
    })
    .then(body => this.getResult(body, 'pEncryptedData'))
  }
}