const BaseOpenAPIClient = require('../base-open-api-client')
const className = 'KLEVerControl'

module.exports = class KLEVerControl extends BaseOpenAPIClient {
  ChangeCreatePackage ({
    vecDistribLocIdsToCreate = [],
    vecDistribLocIdsNotToCreate = []
  }, connection) {
    return this.baseRequest({
      command: `${className}.ChangeCreatePackage`,
      data: {
        vecDistribLocIdsToCreate,
        vecDistribLocIdsNotToCreate
      },
      connection
    })
      .then(this.deserialize)
  }

  /**
   * Initiate downloading of the distributive by URL into SC-server
   * Method is needed to download distributive by URL into SC-server
   * After that the distributive will be available to downloading from SC-server
   * @param {number} lDistribLocId
   * @param {Connection} connection
   */
  async DownloadDistributiveAsync ({ lDistribLocId }, connection) {
    const response = await this.baseRequest({
      command: `${className}.DownloadDistributiveAsync`,
      data: {
        lDistribLocId
      },
      connection
    })
    const result = this.getResult(response)
    return result
  }

  /**
   * Get result of asynchronous operation DownloadDistributiveAsync
   * @param {string} wstrRequestId
   * @param {Connection} connection
   * @returns {string} path to download distributive from SC-server using GET
   */
  async GetDownloadDistributiveResult ({ wstrRequestId }, connection) {
    const response = await this.baseRequest({
      command: `${className}.GetDownloadDistributiveResult`,
      data: {
        wstrRequestId
      },
      connection
    })
    const result = this.getResult(response, 'wstrDownloadPath')
    return result
  }
}
