const BaseOpenAPIGatewayClient = require('../base-open-api-gateway-client')
const className = 'NagHstCtl'

module.exports = class NagHstCtl extends BaseOpenAPIGatewayClient {
  GetHostRuntimeInfo ({ pFilter, connectionId }) {
    return this.baseRequest({
      command: `${className}.GetHostRuntimeInfo`,
      data: {
        pFilter: this.serialize(pFilter)
      },
      connectionId
    })
      .then(this.deserialize)
  }

  SendProductAction ({ szwProduct, szwVersion, nProductAction, connectionId }) {
    return this.baseRequest({
      command: `${className}.SendProductAction`,
      data: {
        szwProduct,
        szwVersion,
        nProductAction
      },
      connectionId
    })
      .then(this.getBody)
  }

  SendTaskAction ({ szwProduct, szwVersion, szwTaskStorageId, nTaskAction, connectionId }) {
    return this.baseRequest({
      command: `${className}.SendTaskAction`,
      data: {
        szwProduct,
        szwVersion,
        szwTaskStorageId,
        nTaskAction
      },
      connectionId
    })
      .then(this.getBody)
  }
}
