const BaseOpenAPIClient = require('../base-open-api-client')
const className = 'QueriesStorage'

module.exports = class QueriesStorage extends BaseOpenAPIClient {

  async GetQuery ({ nId }, connection) {
    const body = await this.baseRequest({
      command: `${className}.GetQuery`,
      data: { nId: parseInt(nId) },
      connection
    })
    return this.getResult(body)
  }

  async GetQueryIds (eType, connection) {
    const body = await this.baseRequest({
      command: `${className}.GetQueryIds`,
      data: { eType: parseInt(eType) },
      connection
    })
    return this.getResult(body)
  }

  async GetQueries (eType, connection) {
    const body = await this.baseRequest({
      command: `${className}.GetQueries`,
      data: { eType: parseInt(eType) },
      connection
    })
    return this.getResult(body)
  }

  async DeleteQuery (nId, connection) {
    const body = await this.baseRequest({
      command: `${className}.DeleteQuery`,
      data: { nId: parseInt(nId) },
      connection
    })
    return this.getBody(body)
  }

  async AddQuery ({ eType, query }, connection) {
    const body = await this.baseRequest({
      command: `${className}.AddQuery`,
      data: {
        eType,
        parData: this.serialize(query),
      },
      connection
    })
    return this.getBody(body)
  }

  async UpdateQuery ({ nId, query }, connection) {
    const body = await this.baseRequest({
      command: `${className}.UpdateQuery`,
      data: {
        nId: parseInt(nId),
        parData: this.serialize(query),
      },
      connection
    })
    return this.getBody(body)
  }

}
