const BaseOpenAPIClient = require('../base-open-api-client')

module.exports = class Request extends BaseOpenAPIClient {
  async send (props, connection) {
    const body = await this.baseRequest({
      ...props,
      connection,
      raw: true
    })
    return this.getBody(body)
  }

  async downloadFile ({ url, asBase64, asString }, connection) {
    const { result: file } = await this.send({
      command: url,
      httpMethod: 'GET'
    }, connection)
    return {
      result: asBase64
        ? file.toString('base64')
        : asString
          ? String.fromCharCode.apply(null, new Int8Array(file))
          : file
    }
  }
}
