const BaseOpenAPIClient = require('../base-open-api-client')
const className = 'SubnetMasks'

module.exports = class SubnetMasks extends BaseOpenAPIClient {

  CreateSubnet ({ pSubnetSettings }, connection) {
    return this.baseRequest({
      command: `${className}.CreateSubnet`,
      data: { pSubnetSettings },
      connection
    })
      .then(this.getBody)
  }

  DeleteSubnet ({ nIpAddress, nMask }, connection) {
    return this.baseRequest({
      command: `${className}.DeleteSubnet`,
      data: { nIpAddress, nMask },
      connection
    })
      .then(this.getBody)
  }

  ModifySubnet ({ nIpAddress, nMask, pSubnetSettings }, connection) {
    return this.baseRequest({
      command: `${className}.ModifySubnet`,
      data: {
        pSubnetSettings,
        nIpAddress,
        nMask
      },
      connection
    })
      .then(this.getBody)
  }

}
