const BaseOpenApiClient = require('../base-open-api-client')
const className = 'UserDevicesApi'

module.exports = class UserDevices extends BaseOpenApiClient {
  /**
   * Add a new tag. Allows to add a new tag value that can be set for a list item
   * @param {Connection} connection
   * @return {Promise.<TResult>}
   */
  GetDevices ({ pUserId } = {}, connection) {
    return this.baseRequest({
      command: `${className}.GetDevices`,
      data: { pUserId },
      connection
    })
      .then(this.deserialize)
  }
}
