"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

require("core-js/modules/es.array.iterator");

require("core-js/modules/es.array.map");

require("core-js/modules/es.object.to-string");

require("core-js/modules/es.promise");

require("core-js/modules/es.string.iterator");

require("core-js/modules/web.dom-collections.iterator");

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

require("regenerator-runtime/runtime");

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var StateRouterAdapterUi = require('../vendor/ui.router/ui-router-adapter');

var CustomUiRouter = require('../vendor/ui.router/custom-ui-router');

var initRouterService = require('../services/router-service');
/**
 * Factory for creating app router
 */


module.exports = function RouterFactory() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      _ref$logger = _ref.logger,
      logger = _ref$logger === void 0 ? console : _ref$logger;

  (0, _classCallCheck2.default)(this, RouterFactory);
  var routerService = initRouterService({
    logger: logger
  });
  var routerInstance = null;
  this.getInstance = getInstance;

  function getInstance(_x) {
    return _getInstance.apply(this, arguments);
  }

  function _getInstance() {
    _getInstance = (0, _asyncToGenerator2.default)(
    /*#__PURE__*/
    _regenerator.default.mark(function _callee(routes) {
      return _regenerator.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (routerInstance) {
                _context.next = 4;
                break;
              }

              _context.next = 3;
              return initRouter(routes);

            case 3:
              routerInstance = _context.sent;

            case 4:
              return _context.abrupt("return", routerInstance);

            case 5:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));
    return _getInstance.apply(this, arguments);
  }

  function initRouter(_x2) {
    return _initRouter.apply(this, arguments);
  }

  function _initRouter() {
    _initRouter = (0, _asyncToGenerator2.default)(
    /*#__PURE__*/
    _regenerator.default.mark(function _callee2(routes) {
      var customUiRouter, adapter;
      return _regenerator.default.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              customUiRouter = new CustomUiRouter();
              customUiRouter.extend({
                getCurrentRoute: routerService.getCurrentRoute
              });
              window.Router = customUiRouter;
              adapter = new StateRouterAdapterUi(logger);
              routerService.connect(adapter);
              _context2.next = 7;
              return Promise.all(routes.map(function (route) {
                return route(routerService);
              }));

            case 7:
              runtime.triggerDelayed('routes:loaded');
              return _context2.abrupt("return", customUiRouter);

            case 9:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    }));
    return _initRouter.apply(this, arguments);
  }
};