"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

require("core-js/modules/es.function.name");

require("core-js/modules/es.object.keys");

require("core-js/modules/web.dom-collections.for-each");

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _require = require('@uirouter/core'),
    UIRouter = _require.UIRouter,
    servicesPlugin = _require.servicesPlugin,
    hashLocationPlugin = _require.hashLocationPlugin;

var initialState = null;
var transitionsCount = null;
/**
 * Extension for @uirouter/core
 * Result CustomUiRouter is used as app router
 */

module.exports =
/*#__PURE__*/
function (_UIRouter) {
  (0, _inherits2.default)(CustomUiRouter, _UIRouter);

  function CustomUiRouter(opts) {
    var _this;

    (0, _classCallCheck2.default)(this, CustomUiRouter);
    _this = (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(CustomUiRouter).call(this, opts));

    _this.plugin(servicesPlugin);

    _this.plugin(hashLocationPlugin);

    _this.hasActiveTransitions = false;
    return _this;
  }
  /**
   * Extend router instance with given fields
   * @param {Object} props - object with fields to extend Router instance with
   */


  (0, _createClass2.default)(CustomUiRouter, [{
    key: "extend",
    value: function extend(props) {
      var _this2 = this;

      Object.keys(props).forEach(function (key) {
        _this2[key] = props[key];
      });
    }
    /**
     * Router start
     * @param {string} stateName - name for fallback state (if there is no current state from url)
     * @param {Object} params - params for initial state
     */

  }, {
    key: "start",
    value: function start(stateName, params) {
      var _this3 = this;

      transitionsCount = 0;
      initialState = stateName;
      this.urlRouter.otherwise(function () {
        return _this3.go(stateName, params);
      });
      this.urlMatcherFactory.$get();
      this.urlRouter.listen();
      this.urlRouter.sync();

      this._handleTransitionState();
    }
    /**
     * Program navigation to state.
     * Signature and implementation is described in vendor library @uirouter/core
     * @param args
     */

  }, {
    key: "go",
    value: function go(stateName, stateParams, locationOptions) {
      var transitionOptions = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};
      if (transitionOptions.skipOnActiveTransition && this.hasActiveTransitions) return;
      transitionsCount = transitionsCount + 1;
      this.stateService.go(stateName, stateParams, locationOptions);
    }
    /**
     * Generation link for current state
     * Signature and implementation is described in vendor library @uirouter/core
     * @param args
     * @return {string} - generated link
     */

  }, {
    key: "makePath",
    value: function makePath() {
      var _this$stateService;

      return (_this$stateService = this.stateService).href.apply(_this$stateService, arguments);
    }
    /**
     * Navigate back based on window history
     */

  }, {
    key: "back",
    value: function back() {
      var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          _ref$skipOnActiveTran = _ref.skipOnActiveTransition,
          skipOnActiveTransition = _ref$skipOnActiveTran === void 0 ? false : _ref$skipOnActiveTran;

      if (skipOnActiveTransition && this.hasActiveTransitions) return;

      if (transitionsCount > 0) {
        transitionsCount = transitionsCount - 1;
        window.history.back();
      } else {
        this.go(initialState);
      }
    }
    /**
     * @return {Object} current route name and params
     */

  }, {
    key: "getCurrentRouteInfo",
    value: function getCurrentRouteInfo() {
      var currentRouteInfo = {
        name: this.stateService.$current.name,
        params: this.stateService.params,
        parent: this.stateService.$current.parent.name
      };
      return currentRouteInfo;
    }
    /**
     * Program navigation to parent state.
     * Difference from go method is that navigation always occures to parent state
     * setTimeout hack to be replaced by events or state transition checker
     * @param controllerState - state which should be passed from controller to compare to
     */

  }, {
    key: "navigateToParent",
    value: function navigateToParent(controllerState) {
      if (this.hasActiveTransitions) return;

      if (this.stateService.$current.name === controllerState) {
        this.go(this.stateService.$current.parent);
      }
    }
    /**
     * Handle transition state. It sets this.hasActiveTransitions variable to true or false according to current
     * transition state
     * Additional method transitionInProgress allows to get value of that param
     */

  }, {
    key: "_handleTransitionState",
    value: function _handleTransitionState() {
      var _this4 = this;

      var everyTransitionMatcher = {};
      this.transitionService.onStart(everyTransitionMatcher, function () {
        _this4.hasActiveTransitions = true;
      });
      this.transitionService.onFinish(everyTransitionMatcher, function () {
        _this4.hasActiveTransitions = false;
      });
    }
  }]);
  return CustomUiRouter;
}(UIRouter);